<template>
  <div>
    <!-- 容器任务单管理 -->
    <p-card title="容器任务单管理">
      <span slot="extra">
        <!-- <p-button type="primary" style="margin-right:10px" @click="showmodel()">添加</p-button> -->
      </span>
      <p-grid-form :label-col="{ span: 8 }" :span="8" :items="config.items" @submit="hanlderSubmitMaintable" />
      <p-table
        ref="table"
        row-key="id"
        bordered
        :columns="config.columns"
        :remoteUrl="config.remoteUrl"
        :remoteParams="remoteParams"
        :rowSelectType="false"
        :data-source="data"
        :scroll="{ x: 1000 }"
      >
        <!-- detailCount -->

        <template slot="detailCount" slot-scope="text, record">
          <a class="count" @click="showmodeldetailCount(text, record)">{{ text }}</a>
        </template>
        <template slot="operation" slot-scope="text, record">
          <!-- {{ text ? '禁用' : '启用' }} -->
          <a @click="showmodel(text)">调整优先级</a>
          <!-- <a-divider type="vertical" />
          <a @click="del(text)">删除</a> -->
        </template>
      </p-table>
    </p-card>

    <p-modal
      title="详情"
      width="50%"
      :visible="visible"
      :confirm-loading="confirmLoading"
      @ok="handleOk"
      @cancel="handleCancel"
    >
      <p-grid-form :label-col="{ span: 8 }" ref="model" :span="8" :items="config.Modelitems" @submit="hanlderSubmit" />
    </p-modal>

    <p-modal
      title="任务数明细"
      width="80%"
      :visible="visibledetailCount"
      :confirm-loading="confirmLoading"
      @ok="handleCancel"
      @cancel="handleCancel"
    >
      <p-grid-form :label-col="{ span: 8 }" :span="8" :items="detailCount.items" @submit="hanlderSubmit" />
      <p-table
        row-key="id"
        bordered
        :columns="detailCount.columns"
        :rowSelectType="false"
        :remoteUrl="detailCount.remoteUrl"
        :remoteParams="detailCountremoteParams"
        :data-source="detailCountdata"
        :scroll="{ x: 2500 }"
      >
      </p-table>
    </p-modal>
  </div>
</template>

<script>
import { diffOption } from '@/views/kzyWMS/utils/index.js'
import config from './config.js'
import { add, deletes, update, findDetailById } from './api'
const base = '/api/service-ai-eis-business-center-eistest'
export default {
  data() {
    return {
      config: config(this),
      data: [],
      detailCount: {
        items: [
          {
            span: 8,
            type: 'input',
            name: 'containerNo',
            label: '容器号',
            value: '',
          },
          {
            span: 8,
            type: 'buttonGroup',
            style: { textAlign: 'right' },
            options: [
              {
                value: '查询',
                icon: 'search',
                btnType: 'primary',
                style: 'margin-right:10px',
                htmlType: 'submit',
              },
              {
                value: '重置',
                icon: 'redo',
                style: 'margin-right:50px',
                on: {
                  click: (event, form) => {
                    console.log(form)
                    form.resetFields()
                  },
                },
              },
            ],
          },
        ],
        columns: [
          {
            dataIndex: 'id',
            key: 'id',
            align: 'center',
            width: 150,
            ellipsis: true,
            title: 'ID',
          },
          {
            title: '上游系统任务单明细ID',
            dataIndex: 'upperSystemTaskDeailId',
            ellipsis: true,
            align: 'center',
            width: 150,
            key: 'upperSystemTaskDeailId',
            // customRender(text) {
            //   text == 10 && (text = '区域')
            //   text == 20 && (text = '接驳口')
            //   return text
            // }
          },
          {
            title: '容器号',
            dataIndex: 'containerNo',
            ellipsis: true,
            align: 'center',
            width: 150,
            key: 'containerNo',
          },
          {
            title: '任务单状态',
            key: 'status',
            width: 150,
            ellipsis: true,
            dataIndex: 'status',
            align: 'center',
            customRender(text) {
              text == 0 && (text = '未开始')
              text == 1 && (text = '进行中')
              text == 2 && (text = '已完成')
              text == 3 && (text = '已暂停')
              text == 4 && (text = '已取消')

              return text
            },
          },
          {
            title: '起始区域',
            dataIndex: 'sourceArea',
            align: 'center',
            ellipsis: true,
            width: 150,
            key: 'sourceArea',
            // customRender(text) {
            //   text == 0 && (text = '不索取')
            //   text == 1 && (text = '索取')
            //   return text
            // }
          },
          {
            title: '起始坐标',
            key: 'sourceLocation',
            width: 150,
            ellipsis: true,
            dataIndex: 'sourceLocation',
            align: 'center',
          },
          {
            title: '目标区域',
            dataIndex: 'targetArea',
            align: 'center',
            width: 150,
            key: 'targetArea',
          },
          {
            title: '目标坐标',
            width: 150,
            dataIndex: 'targetLocation',
            align: 'center',
            key: 'targetLocation',
          },
          {
            title: '创建时间',
            dataIndex: 'createTime',
            width: 150,
            align: 'center',
            key: 'createTime',
          },
          {
            title: '任务明细开始时间',
            dataIndex: 'detailStartTime',
            width: 150,
            align: 'center',
            key: 'detailStartTime',
          },
          {
            title: '任务完成时间',
            dataIndex: 'detailFinishTime',
            width: 150,
            align: 'center',
            key: 'detailFinishTime',
          },
        ],
        remoteUrl: {
          url: base + '/busicontainertask/findDetailById',
          headers: {
            'Content-Type': 'application/JSON',
          },
          method: 'get',
        },
      },
      detailCountdata: [],
      detailCountremoteParams: {
        containerNo: '',
        id: '',
      },
      type: true,
      remoteParams: {
        createTime: '',
        createTimeFrom: '',
        createTimeTo: '',
        detailCount: '',
        priority: '',
        status: '',
        taskFinishTime: '',
        taskStartTime: '',
        typeNo: '',
        upperSystemTaskId: '',
      },
      visible: false,
      visibledetailCount: false,
      confirmLoading: false,
    }
  },
  mounted() {
    // this.getinfo()
  },
  created() {
    diffOption(this.config.columns).then((res) => {
      this.config.columns = res
    })
  },
  methods: {
    //查询任务数明细
    async showmodeldetailCount(text, record) {
      console.log(text, record)
      this.detailCountremoteParams.id = record.id
      this.visibledetailCount = true
      this.detailCountremoteParams = { ...this.detailCountremoteParams }
    },
    hanlderSubmit(e, form) {
      e.preventDefault()
      form.validateFields((error, values) => {
        console.log(error, values, 'valuesvaluesvaluesvaluesvalues')
        // this.queryName = values.name
        // this.queryType = values.type
        // this.getlistCompanyByAuthId()
        if (!error) {
          this.detailCountremoteParams = { ...this.detailCountremoteParams, ...values }
        }
      })
    },
    hanlderSubmitMaintable(e, form) {
      e.preventDefault()
      form.validateFields((error, values) => {
        // console.log(error, values, 'valuesvaluesvaluesvaluesvalues')
        // this.queryName = values.name
        // this.queryType = values.type
        // this.getlistCompanyByAuthId()
        if (!error) {
          this.remoteParams = { ...this.remoteParams, ...values }
        }
      })
    },
    handleOk(e) {
      console.log(this.$refs.model)
      this.$refs.model.form.validateFields(async (err, value) => {
        if (!err) {
          console.log(value)
          this.confirmLoading = true
          if (this.type) {
            let res = await update(value)
            console.log(res)
            if (res.success) {
              this.$message.success(res.message)
              this.visible = false
              this.remoteParams = { ...this.remoteParams }
            } else {
              this.$exception(res)
            }
          } else {
            let res = await add(value)
            console.log(res)

            if (res.success) {
              this.$message.success(res.message)
              this.visible = false
              this.remoteParams = { ...this.remoteParams }
            } else {
              this.$exception(res)
            }
          }

          this.confirmLoading = false
          //
        }
      })
    },
    handleCancel(e) {
      console.log('Clicked cancel button')
      this.visible = false
      this.visibledetailCount = false
    },
    //点击弹出
    showmodel(data) {
      console.log(data)

      this.visible = true
      this.$nextTick(() => {
        this.$refs.model.form.setFieldsValue(data)
      })
      //   if (data) {
      //     this.config.Modelitems.forEach(item => {
      //       item.name == 'areaType' && (item.disabled = true)
      //       item.name == 'areaNo' && (item.disabled = true)
      //     })
      //     this.$nextTick(() => {
      //       this.$refs.model.form.setFieldsValue(data)
      //     })
      //     this.type = true
      //   } else {
      //     this.config.Modelitemsupdate.forEach(item => {
      //       item.disabled = false
      //     })
      //     this.config.Modelitems.forEach(item => {
      //       item.disabled = false
      //     })
      //     console.log(this.config.Modelitems)
      //     this.$nextTick(() => {
      //       this.$refs.model.form.resetFields()
      //     })
      //     this.type = false
      //   }
    },
    del(text) {
      let that = this
      console.log(text)
      this.$confirm({
        title: '确定是否要删除?',
        content: '',
        async onOk() {
          let res = await deletes({ areaNo: text.areaNo })
          if (res.success) {
            that.$message.success('删除成功')
            that.remoteParams = { ...that.remoteParams }
          } else {
            that.$exception(res)
          }
        },
        onCancel() {},
      })
    },
  },
}
</script>

<style lang="less" scoped>
.count {
  padding: 10px;
  padding-left: 25px;
  padding-right: 25px;
}
</style>
